QT       += core gui

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

CONFIG += c++17 console

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    display/opengl.cpp \
    display/variable.cpp \
    main.cpp \
    mainwindow.cpp \

HEADERS += \
    display/display.h \
    display/opengl.h \
    display/variable.h \
    gcode/parse_gcode.h \
    lcnc/enable_adaptive_feed.h \
    lcnc/estop.h \
    lcnc/estop_reset.h \
    lcnc/feed_override.h \
    lcnc/get_position.h \
    lcnc/home.h \
    lcnc/jog.h \
    lcnc/estop.h \
    lcnc/estop_reset.h \
    lcnc/get_position.h \
    lcnc/home.h \
    lcnc/jog.h \
    lcnc/maxvel.h \
    lcnc/mdi.h \
    lcnc/mode_auto.h \
    lcnc/mode_manual.h \
    lcnc/mode_mdi.h \
    lcnc/open_file.h \
    lcnc/pause.h \
    lcnc/reset_interpreter.h \
    lcnc/resume.h \
    lcnc/run_backward.h \
    lcnc/run_forward.h \
    lcnc/spindle_off.h \
    lcnc/spindle_on.h \
    lcnc/spindle_stop.h \
    lcnc/state_off.h \
    lcnc/state_on.h \
    lcnc/step.h \
    lcnc/stop.h \
    lcnc/unhome.h \
    mainwindow.h \

FORMS += \
    mainwindow.ui

INCLUDEPATH += /home/user/linuxcnc/include

LIBS += -Iinclude -Isrc/emc/rs274ngc -Llib -lnml -llinuxcnc  -llinuxcnchal
LIBS += -lGLU

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

DISTFILES += \
    info.txt

RESOURCES += \
    icons/icons.qrc
